require "util"
require "story"

script.on_event(defines.events, function(event)
	if event.name == defines.events.on_tick then
		if event.tick % 60 == 0  then
			for playerIndex, player in pairs(game.players) do
				-- GUI
				if player.gui.top.display == nil then
					player.gui.top.add{name = "display", type = "label", caption = "Speed "..tostring(format_num(game.speed,2,"x","")), style="caption_label_style"}
				end

		        -- increase
				if player.gui.top.decrease == nil then
					local button_decrease = player.gui.top.add{name = "decrease", type = "button", caption = "<", style="fentus-button"}
				end
		
		        -- decrease
				if player.gui.top.increase == nil then
					local button_increase = player.gui.top.add{name = "increase", type = "button", caption = ">", style="fentus-button"}
				end
			end
		end
	elseif event.name == defines.events.on_gui_click then
		local click = event.element

		-- increase
		if click.name == "increase" then
			for playerIndex, player in pairs(game.players) do
				if player.gui.top.increase then
					if game.speed < 10.0 then
						game.speed = game.speed + 0.5
						player.gui.top.display.caption = "Speed "..tostring(format_num(game.speed,2,"x",""))
					end
				end
			end
		end
		
		-- decrease
		if click.name == "decrease" then
			for playerIndex, player in pairs(game.players) do
				if player.gui.top.decrease then
					if game.speed > 0.5 then
						game.speed = game.speed - 0.5
						player.gui.top.display.caption = "Speed "..tostring(format_num(game.speed,2,"x",""))
					end
				end
			end
		end
		
	end
end)

function format_num(amount, decimal, prefix, neg_prefix)
  local str_amount,  formatted, famount, remain

  decimal = decimal or 2 -- default 2 decimal places
  neg_prefix = neg_prefix or "-" -- default negative sign

  famount = math.abs(round(amount,decimal))
  famount = math.floor(famount)

  remain = round(math.abs(amount) - famount, decimal)

  -- comma to separate the thousands
  formatted = comma_value(famount)

  -- attach the decimal portion
  if (decimal > 0) then
    remain = string.sub(tostring(remain),3)
    formatted = formatted .. "." .. remain ..
                string.rep("0", decimal - string.len(remain))
  end

  -- attach prefix string e.g '$' 
  formatted = (prefix or "") .. formatted 

  -- if value is negative then format accordingly
  if (amount<0) then
    if (neg_prefix=="()") then
      formatted = "("..formatted ..")"
    else
      formatted = neg_prefix .. formatted 
    end
  end

  return formatted
end

function round(val, decimal)
  if (decimal) then
    return math.floor( (val * 10^decimal) + 0.5) / (10^decimal)
  else
    return math.floor(val+0.5)
  end
end

function comma_value(amount)
  local formatted = amount
  while true do  
    formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
    if (k==0) then
      break
    end
  end
  return formatted
end